! Copyright (C) 2023 Aleksander Sabak.
! See https://factorcode.org/license.txt for BSD license.
USING: io.streams.string kernel tools.test FALSE FALSE.private ;
IN: FALSE.tests


! scan-FALSE is not tested because testing with a custom lexer
! is too much effort


{ { } } [
    { } [ ] with-FALSE
] unit-test


{ 1 1 } FALSE[ [asd'f{fsd"}"as{fdsaf"[-+*]\]]
must-infer-as


{ "AA" } [
    "A" FALSE[ $] with-FALSE
] unit-test


{ "BA" } [
    "AB" FALSE[ \] with-FALSE
] unit-test


{ "A" } [
    "AB" FALSE[ %] with-FALSE
] unit-test


{ "BCA" } [
    "ABC" FALSE[ @] with-FALSE
] unit-test


{ { 2 1 3 7 2 } } [
    { 2 1 3 7 3 } FALSE[ O] with-FALSE
] unit-test


{ { 2 1 3 7 2 } } [
    { 2 1 3 7 3 } FALSE[ ø] with-FALSE
] unit-test


{ "Hello" } [
    "" FALSE[ 'H'e'l'l'o] with-FALSE
] unit-test


{ { 213 7 } } [
    { } FALSE[ 213 7] with-FALSE
] unit-test


{ { 220 } } [
    { } FALSE[ 213 7+] with-FALSE
] unit-test


{ { 206 } } [
    { } FALSE[ 213 7-] with-FALSE
] unit-test


{ { -2137 } } [
    { } FALSE[ 2137_] with-FALSE
] unit-test


{ { 1491 } } [
    { } FALSE[ 213 7*] with-FALSE
] unit-test


{ { 30 } } [
    { } FALSE[ 213 7/] with-FALSE
] unit-test


{ { 1 } } [
    { } FALSE[ 5 3&] with-FALSE
] unit-test


{ { 7 } } [
    { } FALSE[ 5 3|] with-FALSE
] unit-test


{ { -6 } } [
    { } FALSE[ 5~] with-FALSE
] unit-test


{ { -1 } } [
    { } FALSE[ 5 5=] with-FALSE
] unit-test


{ { 0 } } [
    { } FALSE[ 5 6=] with-FALSE
] unit-test


{ { 0 } } [
    { } FALSE[ 5 6>] with-FALSE
] unit-test


{ { 0 } } [
    { } FALSE[ 5 5>] with-FALSE
] unit-test


{ { -1 } } [
    { } FALSE[ 5 4>] with-FALSE
] unit-test


{ { [ ] } } [
    { } FALSE[ []] with-FALSE
] unit-test


{ { 1 } } [
    { } FALSE[ [1]!] with-FALSE
] unit-test


{ { 1 } } [
    { } FALSE[ 1_[1]?] with-FALSE
] unit-test


{ { } } [
    { } FALSE[ 0[1]?] with-FALSE
] unit-test


{ { } } [
    { } FALSE[ [0][7]#] with-FALSE
] unit-test


{ { 6 } } [
    { } FALSE[ 0 1[][6\]#] with-FALSE
] unit-test


{ { 6 5 4 3 2 1 0 } } [
    { } FALSE[ 7[1-$][$]#] with-FALSE
] unit-test


{ { } } [
    { } FALSE[ {1 2 3}] with-FALSE
] unit-test


{ { [ ] } } [
    { } FALSE[ [{]}]] with-FALSE
] unit-test


{ { } "Hello" } [
    [ { } FALSE[ "Hello"] with-FALSE ] with-string-writer
] unit-test


{ "" } [
    [ FALSE[ "Hello"] ] with-string-writer nip
] unit-test


{ { } "{" } [
    [ { } FALSE[ "{"] with-FALSE ] with-string-writer
] unit-test


{ { } "1" } [
    [ { } FALSE[ {"}"1"] with-FALSE ] with-string-writer
] unit-test


{ { } "]" } [
    [ { } FALSE[ ["]"]!] with-FALSE ] with-string-writer
] unit-test


{ "" "Hello" } [
    [ "olleH" FALSE[ ,,,,,] with-FALSE ] with-string-writer
] unit-test


{ { } "2137" } [
    [ { 2137 } FALSE[ .] with-FALSE ] with-string-writer
] unit-test


{ { 2 1 3 7 } } [
    { 2 1 3 7 } FALSE[ B] with-FALSE
] unit-test


{ { 2 1 3 7 } } [
    { 2 1 3 7 } FALSE[ ß] with-FALSE
] unit-test


{ "Hello" } [
    "Hello" [ "" FALSE[ ^^^^^] with-FALSE ] with-string-reader
] unit-test


{ T{ FALSE-state } } [
    <empty-FALSE-state>
] unit-test


{ T{ FALSE-state } } [
    { } { } <FALSE-state>
] unit-test


{
    T{ FALSE-state
        { stack V{ 97 98 99 } }
        { dictionary H{ { 97 98 } { 99 100 } } }
    }
} [
    "abc" { "ab" "cd" } <FALSE-state>
] unit-test


{ T{ FALSE-state { stack V{ 0 55 } } } } [
    <empty-FALSE-state> FALSE[ 2 1+3\-'7] call
] unit-test


{
    T{ FALSE-state
        { dictionary H{ { 97 3 } { 98 2 } { 99 1 } } }
    }
} [
    { 1 2 3 } { } <FALSE-state> FALSE[ a:b:c:] call
] unit-test


{
    T{ FALSE-state
        { stack V{ 1 2 3 } }
        { dictionary H{ { 97 1 } { 98 2 } { 99 3 } } }
    }
} [
    { } { { CHAR: a 1 } { CHAR: b 2 } { CHAR: c 3 } }
    <FALSE-state> FALSE[ a;b;c;] call
] unit-test


{
    T{ FALSE-state
        { stack V{ 3 2 1 } }
        { dictionary H{ { 97 3 } { 98 2 } { 99 1 } } }
    }
} [
    { 1 2 3 } { } <FALSE-state> FALSE[ a:b:c:a;b;c;] call
] unit-test


{
    T{ FALSE-state
        { stack V{ 16 49 } }
        { dictionary H{ { 97 [ ($) (*) ] } } }
    }
} [
    <empty-FALSE-state> FALSE[ [$*]a:4a;!7a;!] call
] unit-test


{
    { 15 }
    "12345678910111213141516171819202122233524578helloworld"
} [
    [ { } FALSE[ {tests by luatic made for cg41}1 .
    1 1 + .
    4 1 - .
    2 2 * .
    10 2 / .
    6 _ _ .
    4 3 | .
    8 63 & .
    1 _ ~ 9 + .
    10 a : a ; .
    5 $ 1 + + .
    12 42 % .
    42 13 \ % .
    14 42 42 @ . % %
    15 42 42 2O . % %
    42 42 = ["16"]?
    42 41 > ["17"]?
    42 41_ > ["18"]?
    42_ 41 > ["FAIL"]?
    42_ 41_ > ["FAIL"]?
    41_ 42_ > ["19"]?
    ["20"]!
    [["2"]!["1"]!]![[]]%
    0 ["FAIL"]?
    42 ["22"]?
    '2,'3,[$ 1 > [1- $ f;! \ 1- f;! +]?]f:
    33 f;!.'h,"elloworld"] with-FALSE ] with-string-writer
] long-unit-test


{ { 97 -1 } } [
    "a" [ { } FALSE[ ^^] with-FALSE ] with-string-reader
] unit-test
